<?php
/*
  PayAnyWay module for Oscommerce v.3.0
*/

/**
 * The administration side of the PayAnyWay payment module
 */

  class osC_Payment_payanyway extends osC_Payment_Admin {

/**
 * The administrative title of the payment module
 *
 * @var string
 * @access private
 */

    var $_title;

/**
 * The code of the payment module
 *
 * @var string
 * @access private
 */

    var $_code = 'payanyway';

/**
 * The developers name
 *
 * @var string
 * @access private
 */

    var $_author_name = 'PayAnyWay';

/**
 * The developers address
 *
 * @var string
 * @access private
 */

    var $_author_www = 'http://www.payanyway.com';

/**
 * The status of the module
 *
 * @var boolean
 * @access private
 */

    var $_status = false;

/**
 * Constructor
 */

    function osC_Payment_payanyway() {
      global $osC_Language;

      $this->_title = $osC_Language->get('payment_payanyway_title');
      $this->_description = $osC_Language->get('payment_payanyway_description');
      $this->_method_title = $osC_Language->get('payment_payanyway_method_title');
      $this->_status = (defined('MODULE_PAYMENT_PAYANYWAY_STATUS') && (MODULE_PAYMENT_PAYANYWAY_STATUS == '1') ? true : false);
      $this->_sort_order = (defined('MODULE_PAYMENT_PAYANYWAY_SORT_ORDER') ? MODULE_PAYMENT_PAYANYWAY_SORT_ORDER : null);
    }

/**
 * Checks to see if the module has been installed
 *
 * @access public
 * @return boolean
 */

    function isInstalled() {
      return (bool)defined('MODULE_PAYMENT_PAYANYWAY_STATUS');
    }

/**
 * Installs the module
 *
 * @access public
 * @see osC_Payment_Admin::install()
 */

    function install() {
      global $osC_Database;

      parent::install();

      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Enable PayAnyWay Payments', 'MODULE_PAYMENT_PAYANYWAY_STATUS', '-1', 'Do you want to accept PayAnyWay payments?', '6', '0', 'osc_cfg_use_get_boolean_value', 'osc_cfg_set_boolean_value(array(1, -1))', now())");
      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Payment Server', 'MODULE_PAYMENT_PAYANYWAY_SERVER', 'www.payanyway.ru', 'URL of Payment System.', '6', '1', now())");
      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant ID', 'MODULE_PAYMENT_PAYANYWAY_MERCHANT_ID', '', 'Merchant ID in PayAnyWay system. Corresponds to advanced account number of the merchant.', '6', '2', now())");
      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Currency', 'MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE', 'RUB', 'ISO currency code which is used for payment of the order. The currency code must correspond to the currency of the recipient account (Merchant ID)', '6', '3', 'osc_cfg_set_boolean_value(array(\'RUB\',\'USD\',\'EUR\', \'GBP\'))', now())");
      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Data Integrity Code', 'MODULE_PAYMENT_PAYANYWAY_DATA_INTEGRITY_CODE', '', 'The code provides identification of the sender and a possibility of checking the data integrity. It�s only disclosed to PayAnyWay system and registration system of the merchant.', '6', '4', now())");
      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Test Mode', 'MODULE_PAYMENT_PAYANYWAY_TEST_MODE', 'Real', 'It indicates if the request is made in a test mode.', '6', '5', 'osc_cfg_set_boolean_value(array(\'Real\',\'Test\'))', now())");
      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_PAYANYWAY_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '6', now())");
      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_PAYANYWAY_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '7', 'osc_cfg_use_get_zone_class_title', 'osc_cfg_set_zone_classes_pull_down_menu', now())");
      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_PAYANYWAY_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '8', 'osc_cfg_set_order_statuses_pull_down_menu', 'osc_cfg_use_get_order_status_title', now())");
    }

/**
 * Return the configuration parameter keys in an array
 *
 * @access public
 * @return array
 */

    function getKeys() {
      if (!isset($this->_keys)) {
        $this->_keys = array('MODULE_PAYMENT_PAYANYWAY_STATUS',
                             'MODULE_PAYMENT_PAYANYWAY_SERVER',
                             'MODULE_PAYMENT_PAYANYWAY_MERCHANT_ID',
                             'MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE',
                             'MODULE_PAYMENT_PAYANYWAY_DATA_INTEGRITY_CODE',
                             'MODULE_PAYMENT_PAYANYWAY_TEST_MODE',
                             'MODULE_PAYMENT_PAYANYWAY_ZONE',
                             'MODULE_PAYMENT_PAYANYWAY_ORDER_STATUS_ID',
                             'MODULE_PAYMENT_PAYANYWAY_SORT_ORDER');
      }

      return $this->_keys;
    }
  }
?>
