<?php
/*
  PayAnyWay module for Oscommerce v.3.0
*/

  class osC_Payment_payanyway extends osC_Payment {
    var $_title,
        $_code = 'payanyway',
        $_status = false,
        $_sort_order,
        $_order_id;

    function osC_Payment_payanyway() {
      global $osC_Database, $osC_Language, $osC_ShoppingCart;

      $this->_title = $osC_Language->get('payment_payanyway_title');
      $this->_method_title = $osC_Language->get('payment_payanyway_method_title');
      $this->_status = (MODULE_PAYMENT_PAYANYWAY_STATUS == '1') ? true : false;
      $this->_sort_order = MODULE_PAYMENT_PAYANYWAY_SORT_ORDER;

      $this->form_action_url = 'https://'.MODULE_PAYMENT_PAYANYWAY_SERVER.'/assistant.htm';

      if ($this->_status === true) {
        if ((int)MODULE_PAYMENT_PAYANYWAY_ORDER_STATUS_ID > 0) {
          $this->order_status = MODULE_PAYMENT_PAYANYWAY_ORDER_STATUS_ID;
        }

        if ((int)MODULE_PAYMENT_PAYANYWAY_ZONE > 0) {
          $check_flag = false;

          $Qcheck = $osC_Database->query('select zone_id from :table_zones_to_geo_zones where geo_zone_id = :geo_zone_id and zone_country_id = :zone_country_id order by zone_id');
          $Qcheck->bindTable(':table_zones_to_geo_zones', TABLE_ZONES_TO_GEO_ZONES);
          $Qcheck->bindInt(':geo_zone_id', MODULE_PAYMENT_PAYANYWAY_ZONE);
          $Qcheck->bindInt(':zone_country_id', $osC_ShoppingCart->getBillingAddress('country_id'));
          $Qcheck->execute();

          while ($Qcheck->next()) {
            if ($Qcheck->valueInt('zone_id') < 1) {
              $check_flag = true;
              break;
            } elseif ($Qcheck->valueInt('zone_id') == $osC_ShoppingCart->getBillingAddress('zone_id')) {
              $check_flag = true;
              break;
            }
          }

          if ($check_flag === false) {
            $this->_status = false;
          }
        }
      }
    }

    function selection() {
      return array('id' => $this->_code,
                   'module' => $this->_method_title);
    }

    function confirmation() {
      $this->_order_id = osC_Order::insert();
    }

    function process_button() {
      global $osC_Customer, $osC_Currencies, $osC_ShoppingCart, $osC_Language;

        switch (MODULE_PAYMENT_PAYANYWAY_TEST_MODE) {
            case 'Real':
                $test_mode = '0';
                break;
            case 'Test':
                $test_mode = '1';
                break;
        }

//      $transactionId = STORE_NAME . date('Ymdhis') . rand (0, 99999);
      $amount = $osC_Currencies->formatRaw($osC_ShoppingCart->getTotal(), MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE);
	  $amount = number_format($amount, 2, '.', '');

      $process_button_string = osc_draw_hidden_field('MNT_ID', MODULE_PAYMENT_PAYANYWAY_MERCHANT_ID) .
                               osc_draw_hidden_field('MNT_TRANSACTION_ID', $this->_order_id) .
                               osc_draw_hidden_field('MNT_AMOUNT', $amount) .
                               osc_draw_hidden_field('MNT_CURRENCY_CODE', MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE) .
                               osc_draw_hidden_field('MNT_TEST_MODE', $test_mode) .
                               osc_draw_hidden_field('MNT_SIGNATURE', md5(MODULE_PAYMENT_PAYANYWAY_MERCHANT_ID . $transactionId . $amount . MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE . $test_mode . MODULE_PAYMENT_PAYANYWAY_DATA_INTEGRITY_CODE)) .
                               osc_draw_hidden_field('MNT_SUCCESS_URL',  osc_href_link(FILENAME_CHECKOUT, 'payment', 'SSL', null, null, true)) .
                               osc_draw_hidden_field('MNT_FAIL_URL',  osc_href_link(FILENAME_CHECKOUT, 'payment', 'SSL', null, null, true)) .
                               osc_draw_hidden_field('orderId', $this->_order_id) .
                               osc_draw_hidden_field('customerId', $osC_Customer->getID()) .
                               osc_draw_hidden_field('moneta.locale', substr($osC_Language->_code, 0, 2));

      return $process_button_string;
    }

    function process() {
      global $osC_Customer, $osC_ShoppingCart;

      if (isset($_REQUEST['customerId']) && is_numeric($_REQUEST['customerId']) && isset($_REQUEST['orderId']) && is_numeric($_REQUEST['orderId'])) {
        if ($_REQUEST['customerId'] == $osC_Customer->getID()) {
          if (isset($_SESSION['prepOrderID'])) {
            $_prep = explode('-', $_SESSION['prepOrderID']);

            if ( ($_prep[0] == $osC_ShoppingCart->getCartID()) && ($_prep[1] == $_REQUEST['orderId']) ) {
              unset($_SESSION['prepOrderID']);
            }
          }
        }
      }

    }

    function callback() {
      global $osC_Database;

      if (isset($_REQUEST['MNT_ID']) && isset($_REQUEST['MNT_TRANSACTION_ID']) && isset($_REQUEST['MNT_OPERATION_ID'])
		&& isset($_REQUEST['MNT_AMOUNT']) && isset($_REQUEST['MNT_CURRENCY_CODE']) && isset($_REQUEST['MNT_TEST_MODE'])
		&& isset($_REQUEST['MNT_SIGNATURE']) && isset($_REQUEST['orderId']) && isset($_REQUEST['customerId']))
	  {
          if ($_REQUEST['MNT_SIGNATURE'] == md5($_REQUEST['MNT_ID'] . stripslashes($_REQUEST['MNT_TRANSACTION_ID']) . $_REQUEST['MNT_OPERATION_ID'] . $_REQUEST['MNT_AMOUNT'] . $_REQUEST['MNT_CURRENCY_CODE'] . $_REQUEST['MNT_TEST_MODE'] . MODULE_PAYMENT_PAYANYWAY_DATA_INTEGRITY_CODE)) {
                $post_array = array('root' => $_REQUEST);
                $osC_XML = new osC_XML($post_array);

                if (osC_Order::getStatusID($_REQUEST['orderId']) === 4) {
                  $pass = true;

                  osC_Order::process($_REQUEST['orderId'], $this->order_status);
                }
                $Qtransaction = $osC_Database->query('insert into :table_orders_transactions_history (orders_id, transaction_code, transaction_return_value, transaction_return_status, date_added) values (:orders_id, :transaction_code, :transaction_return_value, :transaction_return_status, now())');
                $Qtransaction->bindTable(':table_orders_transactions_history', TABLE_ORDERS_TRANSACTIONS_HISTORY);
                $Qtransaction->bindInt(':orders_id', $_REQUEST['orderId']);
                $Qtransaction->bindInt(':transaction_code', 1);
                $Qtransaction->bindValue(':transaction_return_value', $osC_XML->toXML());
                $Qtransaction->bindInt(':transaction_return_status', ($pass === true) ? 1 : 0);
                $Qtransaction->execute();
                echo "SUCCESS";
          } else echo "FAIL";
      } else echo "FAIL";

    }
  }
?>
